﻿''' <summary>
''' Represents a node in the expression tree.
''' </summary>
Friend Class Token

    ' Fields
    Public ID As TKID
    Public Type As TKTYPE
    Public Value As Object

    ' Methods
    Public Sub New(ByVal value As Object, ByVal id As TKID, ByVal type As TKTYPE)
        Me.Value = value
        Me.ID = id
        Me.Type = type
    End Sub
End Class

''' <summary>
''' Token ID (used when evaluating expressions)
''' </summary>
Friend Enum TKID
    GT
    LT
    GE
    LE
    EQ
    NE
    ADD
    [SUB]
    MUL
    DIV
    DIVINT
    [MOD]
    POWER
    OPEN
    CLOSE
    [END]
    COMMA
    PERIOD
    ATOM
End Enum

''' <summary>
''' Token types (used when building expressions, sequence defines operator priority)
''' </summary>
Friend Enum TKTYPE
    [COMPARE] ' // < > = <= >=
    ADDSUB ' + -
    MULDIV ' * / 
    POWER ' ^
    GROUP ' ( ) , .
    LITERAL ' 123.456 "Hello"
    IDENTIFIER ' functions, variables, bindings
End Enum
